<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 29.60 Index List View</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- font -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>

<body onload="onPageLoading()">
  <div class="container bg-light">
    <h2 class="text-center">Danh sách người dùng đăng ký</h2>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
</body>

<script>
  "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_ROW_TABLE = -1;
    // Biến toàn cục định nghĩa chỉ số các cột tương ứng
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users"
  //user database
  // chuyển json thành object
  function onPageLoading() {
      // hiển thị dữ liệu lên table
         
      var vXHTMLRequest = new XMLHttpRequest();
      goiApi(vXHTMLRequest)
      vXHTMLRequest.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
           showData(vXHTMLRequest)
           addListenerEnvenInfoButton();
        }
      };
    }
    // Hàm xử lý khi click nút chi tiết
    // function onBtnDetailClick(paramButton){
    //   "use strict";
    //   console.log("Nút chi tiết được ấn");
    //   var vUserId = paramButton.dataset.userid;
    //   var vFirstName = paramButton.dataset.firstname;
    //   var vLastName = paramButton.dataset.lastname;
    //   var vAge = paramButton.dataset.age;
    //   console.log("UserId: " + vUserId);
    //   console.log("Firstname: " + vFirstName);
    //   console.log("Lastname: " + vLastName);
    //   console.log("Age: " + vAge);
    // }
    function goiApi(paramXmlHttp) {
          paramXmlHttp.open(
            "GET",
            gBASE_URL ,true);
          paramXmlHttp.send();
        }

        function showData(paramXmlHttp) {
        //   console.log(paramXmlHttp.responseText);
          var vUserData =  JSON.parse(paramXmlHttp.responseText)
          var vUserTable = document.getElementById("user-table")
          var vUserTBody = vUserTable.getElementsByTagName("tbody")[0]
      
          for(var bI =0; bI< vUserData.length;bI++){
             //thêm 1 dòng mới
            var bNewRow = vUserTBody.insertRow(gEND_ROW_TABLE )
             //thêm các ô trên dòng mới
            var vNewId  = bNewRow.insertCell(gEND_ROW_TABLE)
            var vNewFirstName  = bNewRow.insertCell(gEND_ROW_TABLE)
            var vNewLastName  = bNewRow.insertCell(gEND_ROW_TABLE)
            var vNewCountry  = bNewRow.insertCell(gEND_ROW_TABLE)
            var vNewSubject = bNewRow.insertCell(gEND_ROW_TABLE)
            var vNewCustomertype = bNewRow.insertCell(gEND_ROW_TABLE)
            var vNewRegisterStatus = bNewRow.insertCell(gEND_ROW_TABLE)
            var vNewUserAction = bNewRow.insertCell(gEND_ROW_TABLE)
             //điền dữ liệu cho từng ô
           vNewId.innerHTML  = vUserData[bI].id
           vNewFirstName.innerHTML  = vUserData[bI].firstname
           vNewLastName.innerHTML  = vUserData[bI].lastname
           vNewCountry.innerHTML  = vUserData[bI].country
           vNewSubject.innerHTML  = vUserData[bI].subject
           vNewCustomertype.innerHTML  = vUserData[bI].customerType
           vNewRegisterStatus.innerHTML  = vUserData[bI].registerStatus
          

           //button thêm data của dòng
            var vDetailButton =  document.createElement("button")
            vDetailButton.className = "info-user btn btn-info"
      
            vDetailButton.setAttribute("data-id",vUserData[bI].id)
            vDetailButton.setAttribute("data-firstname",vUserData[bI].firstname)
            vDetailButton.setAttribute("data-lastname",vUserData[bI].lastname)
            vDetailButton.setAttribute("data-country",vUserData[bI].country)
            vDetailButton.setAttribute("data-subject",vUserData[bI].subject)
            vDetailButton.setAttribute("data-customer-type",vUserData[bI].customerType)
            vDetailButton.setAttribute("data-register-status",vUserData[bI].registerStatus)
            vDetailButton.innerHTML= "chi tiết"
            vNewUserAction.appendChild(vDetailButton)
          }
        }

        function addListenerEnvenInfoButton(){
          var vDetailButtons = document.getElementsByClassName("btn-info")
          for (var bI=0;bI<vDetailButtons.length;bI++){
            vDetailButtons[bI].addEventListener('click',function(){
              onBtnChiTietClick(this)
            })
          }
        }
        function onBtnChiTietClick(paramDetailButtons){
      var    vUserId = paramDetailButtons.dataset.id
      var  vFirstName = paramDetailButtons.dataset.firstname
      var  vLastName = paramDetailButtons.dataset.lastname
      var    vCountry = paramDetailButtons.dataset.country
          var    vSubject = paramDetailButtons.dataset.subject
          var   vCustomerType = paramDetailButtons.dataset.customerType
          var  vRegisterStatus = paramDetailButtons.dataset.registerStatus

         console.log("thong tin user") 
         
         console.log("User id: ",vUserId) 
         
         console.log("first name: ",vFirstName) 
         
         console.log("last Name: ",vLastName) 
         
         console.log("country: ",vCountry) 
         
         console.log("subkject: ",vSubject) 
         
         console.log("customerType: ",vCustomerType) 
         console.log("Rigister Status: : ",vRegisterStatus) 
         const vDETAIL_FORM_URL = "29.70.html"
    var vUrlSiteToOpen = vDETAIL_FORM_URL 
    + "?id=" + vUserId +
      "&firstname=" + vFirstName +
      "&lastname=" + vLastName +
      "&country=" + vCountry + 
      "&subject=" + vSubject;
    window.location.href = vUrlSiteToOpen;
 }

   
  
</script>

</body>

</html>